"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};

// src/main.ts
var main_exports = {};
__export(main_exports, {
  ExecutionAbortedError: () => ExecutionAbortedError,
  ExecutionError: () => ExecutionError,
  ExecutionTimeoutError: () => ExecutionTimeoutError,
  StateMachine: () => StateMachine
});
module.exports = __toCommonJS(main_exports);

// src/error/ExecutionAbortedError.ts
var ExecutionAbortedError = class extends Error {
  constructor() {
    super("Execution aborted");
    this.name = "ExecutionAbortedError";
  }
};

// src/error/ExecutionTimeoutError.ts
var ExecutionTimeoutError = class extends Error {
  constructor() {
    super("Execution timed out");
    this.name = "ExecutionTimeoutError";
  }
};

// src/error/ErrorWithCause.ts
var _errorCause;
var ErrorWithCause = class extends Error {
  constructor(message, options) {
    super(message);
    __privateAdd(this, _errorCause, void 0);
    __privateSet(this, _errorCause, options?.cause);
  }
  get cause() {
    return __privateGet(this, _errorCause);
  }
};
_errorCause = new WeakMap();

// src/error/ExecutionError.ts
var ExecutionError = class extends ErrorWithCause {
  constructor(caughtError) {
    super(`Execution has failed with the following error: ${caughtError.message}`, { cause: caughtError });
    this.name = "ExecutionError";
  }
};

// src/util/random.ts
function cyrb128(str) {
  let h1 = 1779033703, h2 = 3144134277, h3 = 1013904242, h4 = 2773480762;
  for (let i = 0, k; i < str.length; i++) {
    k = str.charCodeAt(i);
    h1 = h2 ^ Math.imul(h1 ^ k, 597399067);
    h2 = h3 ^ Math.imul(h2 ^ k, 2869860233);
    h3 = h4 ^ Math.imul(h3 ^ k, 951274213);
    h4 = h1 ^ Math.imul(h4 ^ k, 2716044179);
  }
  h1 = Math.imul(h3 ^ h1 >>> 18, 597399067);
  h2 = Math.imul(h4 ^ h2 >>> 22, 2869860233);
  h3 = Math.imul(h1 ^ h3 >>> 17, 951274213);
  h4 = Math.imul(h2 ^ h4 >>> 19, 2716044179);
  return [(h1 ^ h2 ^ h3 ^ h4) >>> 0, (h2 ^ h1) >>> 0, (h3 ^ h1) >>> 0, (h4 ^ h1) >>> 0];
}
function sfc32(a, b, c, d) {
  return function() {
    a >>>= 0;
    b >>>= 0;
    c >>>= 0;
    d >>>= 0;
    let t = a + b | 0;
    a = b ^ b >>> 9;
    b = c + (c << 3) | 0;
    c = c << 21 | c >>> 11;
    d = d + 1 | 0;
    t = t + d | 0;
    c = c + t | 0;
    return (t >>> 0) / 4294967296;
  };
}
function getRandomNumber(min, max, rng = Math.random) {
  return Math.floor(rng() * (max - min + 1)) + min;
}

// src/util/index.ts
var isBrowserEnvironment = typeof window !== "undefined" && typeof window.document !== "undefined";
function isPlainObj(value) {
  return !!value && Object.getPrototypeOf(value) === Object.prototype;
}
function sleep(ms, abortSignal) {
  return new Promise((resolve) => {
    if (abortSignal?.aborted) {
      return resolve();
    }
    const onAbort = () => {
      clearTimeout(timeout);
      resolve();
    };
    const timeout = setTimeout(() => {
      abortSignal?.removeEventListener("abort", onAbort);
      resolve();
    }, ms);
    abortSignal?.addEventListener("abort", onAbort, { once: true });
  });
}
function byteToHex(byte) {
  return byte.toString(16).padStart(2, "0");
}
function isRFC3339Timestamp(date) {
  const regex = /^\d{4}-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01])T([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9])(\.\d+)?(Z|(\+|-)([01][0-9]|2[0-3]):([0-5][0-9]))$/;
  return regex.test(date);
}
function stringifyJSONValue(value) {
  return JSON.stringify(value);
}
function clamp(value, min, max) {
  if (min && value < min)
    return min;
  if (max && value > max)
    return max;
  return value;
}

// src/stateMachine/jsonPath/JsonPath.ts
var import_jsonpath_plus = require("jsonpath-plus");

// src/stateMachine/jsonPath/constraints/BaseJsonPathConstraint.ts
var BaseJSONPathConstraint = class {
  constructor(pathExpression) {
    this.pathExpression = pathExpression;
  }
};

// src/error/RuntimeError.ts
var RuntimeError = class extends ErrorWithCause {
  constructor(message, cause) {
    super(message, { cause });
    this.name = "RuntimeError";
    this.retryable = true;
    this.catchable = true;
  }
  get isRetryable() {
    return this.retryable;
  }
  get isCatchable() {
    return this.catchable;
  }
};

// src/error/predefined/StatesRuntimeError.ts
var StatesRuntimeError = class extends RuntimeError {
  constructor(message = "States.Runtime") {
    super(message);
    this.name = "States.Runtime";
    this.retryable = false;
    this.catchable = false;
  }
};

// src/stateMachine/jsonPath/constraints/DefinedValueConstraint.ts
var DefinedValueConstraint = class extends BaseJSONPathConstraint {
  test(value) {
    if (typeof value === "undefined") {
      throw new StatesRuntimeError(`Path expression '${this.pathExpression}' does not point to a value`);
    }
  }
};

// src/stateMachine/jsonPath/JsonPath.ts
function jsonPathQuery(pathExpression, json, context, options) {
  const defaultConstraints = [];
  if (!options?.ignoreDefinedValueConstraint) {
    defaultConstraints.push(DefinedValueConstraint);
  }
  const constraints = [...defaultConstraints, ...options?.constraints ?? []];
  let evaluation;
  if (pathExpression.startsWith("$$")) {
    evaluation = (0, import_jsonpath_plus.JSONPath)({ path: pathExpression.slice(1), json: context ?? null, wrap: false });
  } else {
    evaluation = (0, import_jsonpath_plus.JSONPath)({ path: pathExpression, json, wrap: false });
  }
  for (const Constraint of constraints) {
    const constraintObject = new Constraint(pathExpression);
    constraintObject.test(evaluation);
  }
  return evaluation;
}

// src/error/predefined/StatesResultPathMatchFailureError.ts
var StatesResultPathMatchFailureError = class extends RuntimeError {
  constructor() {
    super("States.ResultPathMatchFailure");
    this.name = "States.ResultPathMatchFailure";
  }
};

// src/stateMachine/intrinsicFunctions/ArgumentHandling.ts
function validateArgumentType(allowedTypes, argPosition, funcArg, funcName) {
  let matchesAllowedType = false;
  for (const argType of allowedTypes) {
    switch (argType) {
      case "string":
      case "number":
      case "boolean":
        matchesAllowedType = typeof funcArg === argType;
        break;
      case "null":
        matchesAllowedType = funcArg === null;
        break;
      case "array":
        matchesAllowedType = Array.isArray(funcArg);
        break;
      case "object":
        matchesAllowedType = isPlainObj(funcArg);
        break;
      case "any":
        matchesAllowedType = true;
        break;
    }
    if (matchesAllowedType)
      break;
  }
  const expectedType = allowedTypes.map((type) => `'${type}'`).join(" | ");
  if (!matchesAllowedType) {
    throw new StatesRuntimeError(
      `Intrinsic function ${funcName} expected argument ${argPosition} to be of type ${expectedType}, but received ${typeof funcArg}`
    );
  }
}
function validateArgumentConstraints(argConstraints, argPosition, funcArg, funcName) {
  if (argConstraints) {
    let matchesAllConstraints = false;
    for (const constraint of argConstraints) {
      switch (constraint) {
        case "ZERO":
          matchesAllConstraints = funcArg === 0;
          break;
        case "POSITIVE_INTEGER":
          matchesAllConstraints = Number.isInteger(funcArg) && funcArg > 0;
          break;
        case "NEGATIVE_INTEGER":
          matchesAllConstraints = Number.isInteger(funcArg) && funcArg < 0;
          break;
        case "INTEGER":
          matchesAllConstraints = Number.isInteger(funcArg);
          break;
      }
      if (matchesAllConstraints)
        break;
    }
    const expectedConstraints = argConstraints.map((constraint) => `'${constraint}'`).join(" | ");
    if (!matchesAllConstraints) {
      throw new StatesRuntimeError(
        `Intrinsic function ${funcName} expected argument ${argPosition} to satisfy the following constraints: ${expectedConstraints}`
      );
    }
  }
}
function validateArguments(funcDefinition, ...args) {
  if ("exactArgs" in funcDefinition && args.length !== funcDefinition.exactArgs) {
    throw new StatesRuntimeError(
      `Intrinsic function ${funcDefinition.name} expects exactly ${funcDefinition.exactArgs} arguments, but received ${args.length}`
    );
  }
  if ("minArgs" in funcDefinition && args.length < funcDefinition.minArgs) {
    throw new StatesRuntimeError(
      `Intrinsic function ${funcDefinition.name} expects at least ${funcDefinition.minArgs} arguments, but received ${args.length}`
    );
  }
  if ("maxArgs" in funcDefinition && args.length > funcDefinition.maxArgs) {
    throw new StatesRuntimeError(
      `Intrinsic function ${funcDefinition.name} expects at most ${funcDefinition.maxArgs} arguments, but received ${args.length}`
    );
  }
  if ("arguments" in funcDefinition) {
    for (let i = 0; i < funcDefinition.arguments.length; i++) {
      const argDefinition = funcDefinition.arguments[i];
      const funcArg = args[i];
      if (funcArg === void 0)
        break;
      validateArgumentType(argDefinition.allowedTypes, i + 1, funcArg, funcDefinition.name);
      validateArgumentConstraints(argDefinition.constraints, i + 1, funcArg, funcDefinition.name);
    }
  }
  if ("variadicArguments" in funcDefinition) {
    const argDefinition = funcDefinition.variadicArguments;
    for (let i = funcDefinition.arguments?.length ?? 0; i < args.length; i++) {
      const funcArg = args[i];
      validateArgumentType(argDefinition.allowedTypes, i + 1, funcArg, funcDefinition.name);
      validateArgumentConstraints(argDefinition.constraints, i + 1, funcArg, funcDefinition.name);
    }
  }
}
function parseArguments(input, context, ...args) {
  return args.map((arg) => {
    if (arg[0] === "'") {
      const lastSingleQuote = arg.lastIndexOf("'");
      return arg.slice(1, lastSingleQuote);
    }
    if (arg[0] === "$") {
      return jsonPathQuery(arg, input, context);
    }
    return JSON.parse(arg);
  });
}

// src/stateMachine/intrinsicFunctions/BaseIntrinsicFunction.ts
var BaseIntrinsicFunction = class {
  call(input, context, ...args) {
    const parsedArgs = parseArguments(input, context, ...args);
    validateArguments(this.funcDefinition, ...parsedArgs);
    let result = this.execute(...parsedArgs);
    if (typeof result === "string") {
      result = result.replaceAll("\\", "");
    }
    return result;
  }
};

// src/stateMachine/intrinsicFunctions/StatesFormat.ts
var StatesFormat = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.Format",
      minArgs: 1,
      arguments: [
        {
          allowedTypes: ["string"]
        }
      ],
      variadicArguments: {
        allowedTypes: ["string", "boolean", "number", "null"]
      }
    };
  }
  execute(templateStr, ...placeholderValues) {
    const placeholdersNumber = templateStr.match(/\{\}/g)?.length ?? 0;
    if (placeholdersNumber !== placeholderValues.length) {
      throw new StatesRuntimeError(
        `Number of arguments in ${this.funcDefinition.name} do not match the occurrences of {}`
      );
    }
    let i = 0;
    return templateStr.replace(/\{\}/g, () => placeholderValues[i++]);
  }
};

// src/stateMachine/intrinsicFunctions/StatesStringToJson.ts
var StatesStringToJson = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.StringToJson",
      exactArgs: 1,
      arguments: [
        {
          allowedTypes: ["string"]
        }
      ]
    };
  }
  execute(jsonString) {
    return JSON.parse(jsonString);
  }
};

// src/stateMachine/intrinsicFunctions/StatesJsonToString.ts
var StatesJsonToString = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.JsonToString",
      exactArgs: 1,
      arguments: [
        {
          allowedTypes: ["any"]
        }
      ]
    };
  }
  execute(json) {
    return JSON.stringify(json);
  }
};

// src/stateMachine/intrinsicFunctions/StatesArray.ts
var StatesArray = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.Array",
      variadicArguments: {
        allowedTypes: ["any"]
      }
    };
  }
  execute(...args) {
    return args;
  }
};

// src/stateMachine/intrinsicFunctions/StatesArrayPartition.ts
var StatesArrayPartition = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.ArrayPartition",
      exactArgs: 2,
      arguments: [
        {
          allowedTypes: ["array"]
        },
        {
          allowedTypes: ["number"],
          constraints: ["POSITIVE_INTEGER"]
        }
      ]
    };
  }
  execute(array, chunkSize) {
    const partitionedArr = [];
    for (let i = 0; i < array.length; i += chunkSize) {
      const subArray = array.slice(i, i + chunkSize);
      partitionedArr.push(subArray);
    }
    return partitionedArr;
  }
};

// src/stateMachine/intrinsicFunctions/StatesArrayContains.ts
var import_isEqual = __toESM(require("lodash/isEqual.js"), 1);
var StatesArrayContains = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.ArrayContains",
      exactArgs: 2,
      arguments: [
        {
          allowedTypes: ["array"]
        },
        {
          allowedTypes: ["any"]
        }
      ]
    };
  }
  execute(array, searchVal) {
    return array.findIndex((val) => (0, import_isEqual.default)(val, searchVal)) > -1;
  }
};

// src/stateMachine/intrinsicFunctions/StatesArrayRange.ts
var StatesArrayRange = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.ArrayRange",
      exactArgs: 3,
      arguments: [
        {
          allowedTypes: ["number"],
          constraints: ["INTEGER"]
        },
        {
          allowedTypes: ["number"],
          constraints: ["INTEGER"]
        },
        {
          allowedTypes: ["number"],
          constraints: ["POSITIVE_INTEGER", "NEGATIVE_INTEGER"]
        }
      ]
    };
  }
  execute(start, end, step) {
    const slots = (end - start) / step;
    if (slots < 0) {
      return [];
    }
    const arrLength = Math.floor(slots) + 1;
    if (arrLength > 1e3) {
      throw new StatesRuntimeError(
        `Result of intrinsic function ${this.funcDefinition.name} cannot contain more than 1000 items`
      );
    }
    const range = Array.from({ length: arrLength }).map((_, i) => start + step * i);
    return range;
  }
};

// src/stateMachine/intrinsicFunctions/StatesArrayGetItem.ts
var StatesArrayGetItem = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.ArrayGetItem",
      exactArgs: 2,
      arguments: [
        {
          allowedTypes: ["array"]
        },
        {
          allowedTypes: ["number"]
        }
      ]
    };
  }
  execute(array, index) {
    return array[index] ?? null;
  }
};

// src/stateMachine/intrinsicFunctions/StatesArrayLength.ts
var StatesArrayLength = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.ArrayLength",
      exactArgs: 1,
      arguments: [
        {
          allowedTypes: ["array"]
        }
      ]
    };
  }
  execute(array) {
    return array.length;
  }
};

// src/stateMachine/intrinsicFunctions/StatesArrayUnique.ts
var import_isEqual2 = __toESM(require("lodash/isEqual.js"), 1);
var import_uniqWith = __toESM(require("lodash/uniqWith.js"), 1);
var StatesArrayUnique = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.ArrayUnique",
      exactArgs: 1,
      arguments: [
        {
          allowedTypes: ["array"]
        }
      ]
    };
  }
  execute(array) {
    return (0, import_uniqWith.default)(array, import_isEqual2.default);
  }
};

// src/stateMachine/intrinsicFunctions/StatesBase64Encode.ts
var StatesBase64Encode = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.Base64Encode",
      exactArgs: 1,
      arguments: [
        {
          allowedTypes: ["string"]
        }
      ]
    };
  }
  execute(str) {
    if (str.length > 1e4) {
      throw new StatesRuntimeError(
        `Intrinsic function ${this.funcDefinition.name} cannot encode a string with more than 10,000 characters`
      );
    }
    return btoa(str);
  }
};

// src/stateMachine/intrinsicFunctions/StatesBase64Decode.ts
var StatesBase64Decode = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.Base64Decode",
      exactArgs: 1,
      arguments: [
        {
          allowedTypes: ["string"]
        }
      ]
    };
  }
  execute(str) {
    if (str.length > 1e4) {
      throw new StatesRuntimeError(
        `Intrinsic function ${this.funcDefinition.name} cannot decode a Base64 string with more than 10,000 characters`
      );
    }
    return atob(str);
  }
};

// src/stateMachine/intrinsicFunctions/StatesHash.ts
var import_md5 = __toESM(require("crypto-js/md5.js"), 1);
var import_sha1 = __toESM(require("crypto-js/sha1.js"), 1);
var import_sha256 = __toESM(require("crypto-js/sha256.js"), 1);
var import_sha384 = __toESM(require("crypto-js/sha384.js"), 1);
var import_sha512 = __toESM(require("crypto-js/sha512.js"), 1);
var StatesHash = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.Hash",
      exactArgs: 2,
      arguments: [
        {
          allowedTypes: ["string"]
        },
        {
          allowedTypes: ["string"]
        }
      ]
    };
  }
  execute(str, algorithm) {
    if (str.length > 1e4) {
      throw new StatesRuntimeError(
        `Intrinsic function ${this.funcDefinition.name} cannot hash a string with more than 10,000 characters`
      );
    }
    const algorithms = ["MD5", "SHA-1", "SHA-256", "SHA-384", "SHA-512"];
    const supportedAlgorithms = algorithms.join(", ");
    if (!algorithms.includes(algorithm)) {
      throw new StatesRuntimeError(
        `Unsupported hashing algorithm provided to intrinsic function ${this.funcDefinition.name}. The supported algorithms are: ${supportedAlgorithms}`
      );
    }
    switch (algorithm) {
      case "MD5":
        return (0, import_md5.default)(str).toString();
      case "SHA-1":
        return (0, import_sha1.default)(str).toString();
      case "SHA-256":
        return (0, import_sha256.default)(str).toString();
      case "SHA-384":
        return (0, import_sha384.default)(str).toString();
      case "SHA-512":
        return (0, import_sha512.default)(str).toString();
    }
  }
};

// src/stateMachine/intrinsicFunctions/StatesJsonMerge.ts
var StatesJsonMerge = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.JsonMerge",
      exactArgs: 3,
      arguments: [
        {
          allowedTypes: ["object"]
        },
        {
          allowedTypes: ["object"]
        },
        {
          allowedTypes: ["boolean"]
        }
      ]
    };
  }
  execute(obj1, obj2, isDeepMerge) {
    if (isDeepMerge) {
      throw new StatesRuntimeError(
        `Deep merge option is not supported in ${this.funcDefinition.name}. Third argument must be set to false instead of true`
      );
    }
    return Object.assign(obj1, obj2);
  }
};

// src/stateMachine/intrinsicFunctions/StatesMathRandom.ts
var StatesMathRandom = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.MathRandom",
      minArgs: 2,
      arguments: [
        {
          allowedTypes: ["number"],
          constraints: ["INTEGER"]
        },
        {
          allowedTypes: ["number"],
          constraints: ["INTEGER"]
        },
        {
          allowedTypes: ["number"]
        }
      ]
    };
  }
  execute(min, max, seed) {
    const [s1, s2, s3, s4] = cyrb128((seed ?? Date.now()).toString());
    const rng = sfc32(s1, s2, s3, s4);
    return getRandomNumber(min, max, rng);
  }
};

// src/stateMachine/intrinsicFunctions/StatesMathAdd.ts
var StatesMathAdd = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.MathAdd",
      exactArgs: 2,
      arguments: [
        {
          allowedTypes: ["number"]
        },
        {
          allowedTypes: ["number"]
        }
      ]
    };
  }
  execute(num1, num2) {
    return num1 + num2;
  }
};

// src/stateMachine/intrinsicFunctions/StatesStringSplit.ts
var StatesStringSplit = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.StringSplit",
      exactArgs: 2,
      arguments: [
        {
          allowedTypes: ["string"]
        },
        {
          allowedTypes: ["string"]
        }
      ]
    };
  }
  execute(str, separator) {
    return str.split(separator);
  }
};

// src/stateMachine/intrinsicFunctions/StatesUUID.ts
var StatesUUID = class extends BaseIntrinsicFunction {
  constructor() {
    super();
    this.funcDefinition = {
      name: "States.UUID"
    };
  }
  execute() {
    const octets = new Uint8Array(16);
    for (let i = 0; i < octets.length; i++) {
      octets[i] = getRandomNumber(0, 255);
    }
    octets[6] = octets[6] & 127;
    octets[6] = octets[6] | 64;
    octets[6] = octets[6] & 223;
    octets[6] = octets[6] & 239;
    octets[8] = octets[8] | 128;
    octets[8] = octets[8] & 191;
    const b0 = byteToHex(octets[0]);
    const b1 = byteToHex(octets[1]);
    const b2 = byteToHex(octets[2]);
    const b3 = byteToHex(octets[3]);
    const b4 = byteToHex(octets[4]);
    const b5 = byteToHex(octets[5]);
    const b6 = byteToHex(octets[6]);
    const b7 = byteToHex(octets[7]);
    const b8 = byteToHex(octets[8]);
    const b9 = byteToHex(octets[9]);
    const b10 = byteToHex(octets[10]);
    const b11 = byteToHex(octets[11]);
    const b12 = byteToHex(octets[12]);
    const b13 = byteToHex(octets[13]);
    const b14 = byteToHex(octets[14]);
    const b15 = byteToHex(octets[15]);
    return `${b0}${b1}${b2}${b3}-${b4}${b5}-${b6}${b7}-${b8}${b9}-${b10}${b11}${b12}${b13}${b14}${b15}`;
  }
};

// src/stateMachine/IntrinsicFunctionEvaluation.ts
var functions = {
  "States.Format": new StatesFormat(),
  "States.StringToJson": new StatesStringToJson(),
  "States.JsonToString": new StatesJsonToString(),
  "States.Array": new StatesArray(),
  "States.ArrayPartition": new StatesArrayPartition(),
  "States.ArrayContains": new StatesArrayContains(),
  "States.ArrayRange": new StatesArrayRange(),
  "States.ArrayGetItem": new StatesArrayGetItem(),
  "States.ArrayLength": new StatesArrayLength(),
  "States.ArrayUnique": new StatesArrayUnique(),
  "States.Base64Encode": new StatesBase64Encode(),
  "States.Base64Decode": new StatesBase64Decode(),
  "States.Hash": new StatesHash(),
  "States.JsonMerge": new StatesJsonMerge(),
  "States.MathRandom": new StatesMathRandom(),
  "States.MathAdd": new StatesMathAdd(),
  "States.StringSplit": new StatesStringSplit(),
  "States.UUID": new StatesUUID()
};
function evaluateIntrinsicFunction(intrinsicFunction, input, context) {
  const openingParensIdx = intrinsicFunction.indexOf("(");
  const funcName = intrinsicFunction.slice(0, openingParensIdx);
  const funcArgs = intrinsicFunction.slice(openingParensIdx + 1, intrinsicFunction.length - 1);
  const splitArgs = [];
  let partialArg = "";
  let parensCount = 0;
  let apostropheCount = 0;
  for (let i = 0; i < funcArgs.length; i++) {
    const char = funcArgs[i];
    if (char === "(") {
      parensCount++;
    } else if (char === ")") {
      parensCount--;
    }
    if (char === "'" && partialArg[partialArg.length - 1] !== "\\") {
      if (apostropheCount === 1) {
        apostropheCount--;
      } else {
        apostropheCount++;
      }
    }
    if (char === "," && parensCount === 0 && apostropheCount === 0 || i === funcArgs.length - 1) {
      if (i === funcArgs.length - 1)
        partialArg += char;
      partialArg = partialArg.trim();
      if (partialArg.startsWith("States")) {
        const evaluatedNestedFunction = evaluateIntrinsicFunction(partialArg, input, context);
        splitArgs.push(JSON.stringify(evaluatedNestedFunction));
      } else {
        splitArgs.push(partialArg);
      }
      partialArg = "";
    } else {
      partialArg += char;
    }
  }
  return functions[funcName].call(input, context, ...splitArgs);
}

// src/stateMachine/InputOutputProcessing.ts
var import_cloneDeep = __toESM(require("lodash/cloneDeep.js"), 1);
var import_set = __toESM(require("lodash/set.js"), 1);
function processInputPath(path, input, context) {
  if (path === void 0) {
    return input;
  }
  if (path === null) {
    return {};
  }
  return jsonPathQuery(path, input, context);
}
function processPayloadTemplate(payloadTemplate, json, context) {
  const resolvedProperties = Object.entries(payloadTemplate).map(([key, value]) => {
    let sanitizedKey = key;
    let resolvedValue = value;
    if (isPlainObj(value)) {
      resolvedValue = processPayloadTemplate(value, json, context);
    }
    if (key.endsWith(".$") && typeof value === "string") {
      sanitizedKey = key.replace(".$", "");
      if (value.startsWith("$")) {
        resolvedValue = jsonPathQuery(value, json, context);
      } else {
        resolvedValue = evaluateIntrinsicFunction(value, json, context);
      }
    }
    return [sanitizedKey, resolvedValue];
  });
  return Object.fromEntries(resolvedProperties);
}
function processResultPath(path, rawInput, result) {
  if (path === void 0) {
    return result;
  }
  if (path === null) {
    return rawInput;
  }
  const sanitizedPath = path.replace("$.", "");
  if (isPlainObj(rawInput)) {
    const clonedRawInput = (0, import_cloneDeep.default)(rawInput);
    return (0, import_set.default)(clonedRawInput, sanitizedPath, result);
  }
  throw new StatesResultPathMatchFailureError();
}
function processOutputPath(path, result, context) {
  if (path === void 0) {
    return result;
  }
  if (path === null) {
    return {};
  }
  return jsonPathQuery(path, result, context);
}

// src/stateMachine/stateActions/BaseStateAction.ts
var BaseStateAction = class {
  constructor(stateDefinition, stateName) {
    this.stateDefinition = stateDefinition;
    this.stateName = stateName;
  }
  buildExecutionResult(stateResult) {
    const executionResult = { stateResult, nextState: "", isEndState: false };
    if ("Next" in this.stateDefinition) {
      executionResult.nextState = this.stateDefinition.Next;
    }
    if ("End" in this.stateDefinition) {
      executionResult.isEndState = this.stateDefinition.End;
    }
    return executionResult;
  }
};

// src/error/predefined/StatesNoChoiceMatchedError.ts
var StatesNoChoiceMatchedError = class extends RuntimeError {
  constructor() {
    super("States.NoChoiceMatched");
    this.name = "States.NoChoiceMatched";
  }
};

// src/stateMachine/jsonPath/constraints/StringConstraint.ts
var StringConstraint = class extends BaseJSONPathConstraint {
  test(value) {
    if (typeof value !== "string") {
      throw new StatesRuntimeError(
        `Path expression '${this.pathExpression}' evaluated to ${stringifyJSONValue(value)}, but expected a string`
      );
    }
  }
};

// src/stateMachine/jsonPath/constraints/NumberConstraint.ts
var NumberConstraint = class extends BaseJSONPathConstraint {
  test(value) {
    if (typeof value !== "number") {
      throw new StatesRuntimeError(
        `Path expression '${this.pathExpression}' evaluated to ${stringifyJSONValue(value)}, but expected a number`
      );
    }
  }
};

// src/stateMachine/jsonPath/constraints/BooleanConstraint.ts
var BooleanConstraint = class extends BaseJSONPathConstraint {
  test(value) {
    if (typeof value !== "boolean") {
      throw new StatesRuntimeError(
        `Path expression '${this.pathExpression}' evaluated to ${stringifyJSONValue(value)}, but expected a boolean`
      );
    }
  }
};

// src/stateMachine/jsonPath/constraints/RFC3339TimestampConstraint.ts
var RFC3339TimestampConstraint = class extends BaseJSONPathConstraint {
  test(value) {
    if (typeof value !== "string" || !isRFC3339Timestamp(value)) {
      throw new StatesRuntimeError(
        `Path expression '${this.pathExpression}' evaluated to ${stringifyJSONValue(
          value
        )}, but expected a timestamp conforming to the RFC3339 profile`
      );
    }
  }
};

// src/stateMachine/stateActions/ChoiceStateAction.ts
var import_wildcard_match = __toESM(require("wildcard-match"), 1);
var ChoiceStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
  }
  testChoiceRule(choiceRule, input, context) {
    if ("And" in choiceRule) {
      return choiceRule.And.every((rule) => this.testChoiceRule(rule, input, context));
    }
    if ("Or" in choiceRule) {
      return choiceRule.Or.some((rule) => this.testChoiceRule(rule, input, context));
    }
    if ("Not" in choiceRule) {
      return !this.testChoiceRule(choiceRule.Not, input, context);
    }
    if ("StringEquals" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue === choiceRule.StringEquals;
    }
    if ("StringEqualsPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const stringValue = jsonPathQuery(choiceRule.StringEqualsPath, input, context, {
        constraints: [StringConstraint]
      });
      return varValue === stringValue;
    }
    if ("StringLessThan" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue < choiceRule.StringLessThan;
    }
    if ("StringLessThanPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const stringValue = jsonPathQuery(choiceRule.StringLessThanPath, input, context, {
        constraints: [StringConstraint]
      });
      return varValue < stringValue;
    }
    if ("StringGreaterThan" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue > choiceRule.StringGreaterThan;
    }
    if ("StringGreaterThanPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const stringValue = jsonPathQuery(choiceRule.StringGreaterThanPath, input, context, {
        constraints: [StringConstraint]
      });
      return varValue > stringValue;
    }
    if ("StringLessThanEquals" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue <= choiceRule.StringLessThanEquals;
    }
    if ("StringLessThanEqualsPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const stringValue = jsonPathQuery(choiceRule.StringLessThanEqualsPath, input, context, {
        constraints: [StringConstraint]
      });
      return varValue <= stringValue;
    }
    if ("StringGreaterThanEquals" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue >= choiceRule.StringGreaterThanEquals;
    }
    if ("StringGreaterThanEqualsPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const stringValue = jsonPathQuery(choiceRule.StringGreaterThanEqualsPath, input, context, {
        constraints: [StringConstraint]
      });
      return varValue >= stringValue;
    }
    if ("StringMatches" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const isMatch = (0, import_wildcard_match.default)(choiceRule.StringMatches, { separator: false });
      return isMatch(varValue);
    }
    if ("NumericEquals" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue === choiceRule.NumericEquals;
    }
    if ("NumericEqualsPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const numberValue = jsonPathQuery(choiceRule.NumericEqualsPath, input, context, {
        constraints: [NumberConstraint]
      });
      return varValue === numberValue;
    }
    if ("NumericLessThan" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue < choiceRule.NumericLessThan;
    }
    if ("NumericLessThanPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const numberValue = jsonPathQuery(choiceRule.NumericLessThanPath, input, context, {
        constraints: [NumberConstraint]
      });
      return varValue < numberValue;
    }
    if ("NumericGreaterThan" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue > choiceRule.NumericGreaterThan;
    }
    if ("NumericGreaterThanPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const numberValue = jsonPathQuery(choiceRule.NumericGreaterThanPath, input, context, {
        constraints: [NumberConstraint]
      });
      return varValue > numberValue;
    }
    if ("NumericLessThanEquals" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue <= choiceRule.NumericLessThanEquals;
    }
    if ("NumericLessThanEqualsPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const numberValue = jsonPathQuery(choiceRule.NumericLessThanEqualsPath, input, context, {
        constraints: [NumberConstraint]
      });
      return varValue <= numberValue;
    }
    if ("NumericGreaterThanEquals" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue >= choiceRule.NumericGreaterThanEquals;
    }
    if ("NumericGreaterThanEqualsPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const numberValue = jsonPathQuery(choiceRule.NumericGreaterThanEqualsPath, input, context, {
        constraints: [NumberConstraint]
      });
      return varValue >= numberValue;
    }
    if ("BooleanEquals" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      return varValue === choiceRule.BooleanEquals;
    }
    if ("BooleanEqualsPath" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const booleanValue = jsonPathQuery(choiceRule.BooleanEqualsPath, input, context, {
        constraints: [BooleanConstraint]
      });
      return varValue === booleanValue;
    }
    if ("TimestampEquals" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(choiceRule.TimestampEquals);
      return varValue.getTime() === timestampValue.getTime();
    }
    if ("TimestampEqualsPath" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(
        jsonPathQuery(choiceRule.TimestampEqualsPath, input, context, {
          constraints: [RFC3339TimestampConstraint]
        })
      );
      return varValue.getTime() === timestampValue.getTime();
    }
    if ("TimestampLessThan" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(choiceRule.TimestampLessThan);
      return varValue < timestampValue;
    }
    if ("TimestampLessThanPath" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(
        jsonPathQuery(choiceRule.TimestampLessThanPath, input, context, {
          constraints: [RFC3339TimestampConstraint]
        })
      );
      return varValue < timestampValue;
    }
    if ("TimestampGreaterThan" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(choiceRule.TimestampGreaterThan);
      return varValue > timestampValue;
    }
    if ("TimestampGreaterThanPath" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(
        jsonPathQuery(choiceRule.TimestampGreaterThanPath, input, context, {
          constraints: [RFC3339TimestampConstraint]
        })
      );
      return varValue > timestampValue;
    }
    if ("TimestampLessThanEquals" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(choiceRule.TimestampLessThanEquals);
      return varValue <= timestampValue;
    }
    if ("TimestampLessThanEqualsPath" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(
        jsonPathQuery(choiceRule.TimestampLessThanEqualsPath, input, context, {
          constraints: [RFC3339TimestampConstraint]
        })
      );
      return varValue <= timestampValue;
    }
    if ("TimestampGreaterThanEquals" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(choiceRule.TimestampGreaterThanEquals);
      return varValue >= timestampValue;
    }
    if ("TimestampGreaterThanEqualsPath" in choiceRule) {
      const varValue = new Date(jsonPathQuery(choiceRule.Variable, input, context));
      const timestampValue = new Date(
        jsonPathQuery(choiceRule.TimestampGreaterThanEqualsPath, input, context, {
          constraints: [RFC3339TimestampConstraint]
        })
      );
      return varValue >= timestampValue;
    }
    if ("IsNull" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const isNullTrue = choiceRule.IsNull;
      return isNullTrue && varValue === null;
    }
    if ("IsPresent" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context, { ignoreDefinedValueConstraint: true });
      const IsPresentTrue = choiceRule.IsPresent;
      return IsPresentTrue && varValue !== void 0;
    }
    if ("IsNumeric" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const IsNumericTrue = choiceRule.IsNumeric;
      return IsNumericTrue && typeof varValue === "number";
    }
    if ("IsString" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const IsStringTrue = choiceRule.IsString;
      return IsStringTrue && typeof varValue === "string";
    }
    if ("IsBoolean" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const IsBooleanTrue = choiceRule.IsBoolean;
      return IsBooleanTrue && typeof varValue === "boolean";
    }
    if ("IsTimestamp" in choiceRule) {
      const varValue = jsonPathQuery(choiceRule.Variable, input, context);
      const IsTimestampTrue = choiceRule.IsTimestamp;
      return IsTimestampTrue && isRFC3339Timestamp(varValue);
    }
    return false;
  }
  async execute(input, context, options) {
    const state = this.stateDefinition;
    for (const choice of state.Choices) {
      const choiceIsMatch = this.testChoiceRule(choice, input, context);
      if (choiceIsMatch) {
        return { stateResult: input, nextState: choice.Next, isEndState: false };
      }
    }
    if (state.Default) {
      return { stateResult: input, nextState: state.Default, isEndState: false };
    }
    throw new StatesNoChoiceMatchedError();
  }
};

// src/error/FailStateError.ts
var FailStateError = class extends RuntimeError {
  constructor(name = "FailStateError", message = "Execution failed because of a Fail state") {
    super(message);
    this.name = name;
  }
};

// src/stateMachine/stateActions/FailStateAction.ts
var FailStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
  }
  async execute(input, context, options) {
    const state = this.stateDefinition;
    let error = state.Error;
    let cause = state.Cause;
    if (state.ErrorPath) {
      error = jsonPathQuery(state.ErrorPath, input, context, {
        constraints: [StringConstraint]
      });
    }
    if (state.CausePath) {
      cause = jsonPathQuery(state.CausePath, input, context, {
        constraints: [StringConstraint]
      });
    }
    throw new FailStateError(error, cause);
  }
};

// src/stateMachine/jsonPath/constraints/ArrayConstraint.ts
var ArrayConstraint = class extends BaseJSONPathConstraint {
  test(value) {
    if (!Array.isArray(value)) {
      throw new StatesRuntimeError(
        `Path expression '${this.pathExpression}' evaluated to ${stringifyJSONValue(value)}, but expected an array`
      );
    }
  }
};

// src/stateMachine/jsonPath/constraints/IntegerConstraint.ts
var IntegerConstraint = class extends BaseJSONPathConstraint {
  test(value) {
    if (!Number.isInteger(value)) {
      throw new StatesRuntimeError(
        `Path expression '${this.pathExpression}' evaluated to ${stringifyJSONValue(value)}, but expected an integer`
      );
    }
  }
  static greaterThanOrEqual(n) {
    return class extends this {
      test(value) {
        super.test(value);
        if (value < n) {
          throw new StatesRuntimeError(
            `Path expression '${this.pathExpression}' evaluated to ${stringifyJSONValue(
              value
            )}, but expected an integer >= ${n}`
          );
        }
      }
    };
  }
};

// src/stateMachine/stateActions/MapStateAction.ts
var import_p_limit = __toESM(require("p-limit"), 1);
var DEFAULT_MAX_CONCURRENCY = 40;
var MapStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
    this.executionAbortFuncs = [];
  }
  async forwardEventsToRootEventLogger(eventLogger, executionEventLogs, index, parentStateRawInput) {
    if (!eventLogger)
      return;
    for await (const event of executionEventLogs) {
      eventLogger.forwardNestedMapEvent(event, index, this.stateName, parentStateRawInput);
    }
  }
  processItem(stateMachine, item, input, context, index, options) {
    const state = this.stateDefinition;
    let paramValue;
    context["Map"] = {
      Item: {
        Index: index,
        Value: item
      }
    };
    if (state.Parameters || state.ItemSelector) {
      const parameters = state.ItemSelector ?? state.Parameters;
      paramValue = processPayloadTemplate(parameters, input, context);
    }
    const execution = stateMachine.run(paramValue ?? item, options.runOptions);
    this.executionAbortFuncs.push(execution.abort);
    this.forwardEventsToRootEventLogger(options.eventLogger, execution.eventLogs, index, options.rawInput);
    return execution.result;
  }
  async execute(input, context, options) {
    const state = this.stateDefinition;
    let items = input;
    if (state.ItemsPath) {
      items = jsonPathQuery(state.ItemsPath, input, context, {
        constraints: [ArrayConstraint]
      });
    }
    if (!Array.isArray(items)) {
      throw new StatesRuntimeError("Input of Map state must be an array or ItemsPath property must point to an array");
    }
    const iteratorDefinition = state.ItemProcessor ?? state.Iterator;
    const iteratorStateMachine = new StateMachine(iteratorDefinition, {
      ...options.stateMachineOptions,
      validationOptions: { noValidate: true }
    });
    let maxConcurrency = state.MaxConcurrency;
    if (state.MaxConcurrencyPath) {
      maxConcurrency = jsonPathQuery(state.MaxConcurrencyPath, input, context, {
        constraints: [IntegerConstraint.greaterThanOrEqual(0)],
        ignoreDefinedValueConstraint: true
      });
    }
    const limit = (0, import_p_limit.default)(maxConcurrency || DEFAULT_MAX_CONCURRENCY);
    const processedItemsPromise = items.map(
      (item, i) => limit(() => this.processItem(iteratorStateMachine, item, input, context, i, options))
    );
    try {
      const result = await Promise.all(processedItemsPromise);
      return this.buildExecutionResult(result);
    } catch (error) {
      this.executionAbortFuncs.forEach((abort) => abort());
      if (error instanceof ExecutionError) {
        throw error.cause;
      }
      throw error;
    } finally {
      delete context["Map"];
    }
  }
};

// src/stateMachine/stateActions/ParallelStateAction.ts
var import_p_limit2 = __toESM(require("p-limit"), 1);
var DEFAULT_CONCURRENCY = 40;
var ParallelStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
    this.executionAbortFuncs = [];
  }
  async forwardEventsToRootEventLogger(eventLogger, executionEventLogs, parentStateRawInput) {
    if (!eventLogger)
      return;
    for await (const event of executionEventLogs) {
      eventLogger.forwardNestedParallelEvent(event, this.stateName, parentStateRawInput);
    }
  }
  processBranch(branch, input, context, options) {
    const stateMachine = new StateMachine(branch, {
      ...options.stateMachineOptions,
      validationOptions: { noValidate: true }
    });
    const execution = stateMachine.run(input, options.runOptions);
    this.executionAbortFuncs.push(execution.abort);
    this.forwardEventsToRootEventLogger(options.eventLogger, execution.eventLogs, options.rawInput);
    return execution.result;
  }
  async execute(input, context, options) {
    const state = this.stateDefinition;
    const limit = (0, import_p_limit2.default)(DEFAULT_CONCURRENCY);
    const processedBranchesPromise = state.Branches.map(
      (branch) => limit(() => this.processBranch(branch, input, context, options))
    );
    try {
      const result = await Promise.all(processedBranchesPromise);
      return this.buildExecutionResult(result);
    } catch (error) {
      this.executionAbortFuncs.forEach((abort) => abort());
      if (error instanceof ExecutionError) {
        throw error.cause;
      }
      throw error;
    }
  }
};

// src/stateMachine/stateActions/PassStateAction.ts
var PassStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
  }
  async execute(input, context, options) {
    if (this.stateDefinition.Result) {
      return this.buildExecutionResult(this.stateDefinition.Result);
    }
    return this.buildExecutionResult(input);
  }
};

// src/stateMachine/stateActions/SucceedStateAction.ts
var SucceedStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
  }
  async execute(input, context, options) {
    return { stateResult: input, nextState: "", isEndState: true };
  }
};

// src/error/predefined/StatesTimeoutError.ts
var StatesTimeoutError = class extends RuntimeError {
  constructor() {
    super("States.Timeout");
    this.name = "States.Timeout";
  }
};

// src/aws/LambdaClient.ts
var import_client_lambda = require("@aws-sdk/client-lambda");
var import_credential_providers = require("@aws-sdk/credential-providers");

// src/error/LambdaInvocationError.ts
var LambdaInvocationError = class extends RuntimeError {
  constructor(name, message, cause) {
    super(message, cause);
    this.name = name;
  }
};

// src/aws/LambdaClient.ts
var LambdaClient = class {
  constructor(config) {
    this.client = new import_client_lambda.LambdaClient({});
    if (config) {
      if (!config.region) {
        throw new StatesRuntimeError(
          "'awsConfig' option was specified in state machine constructor, but 'region' property is not set."
        );
      }
      if (!config.credentials) {
        throw new StatesRuntimeError(
          "'awsConfig' option was specified in state machine constructor, but 'credentials' property is not set."
        );
      }
      if (config.credentials) {
        const credentialsTypes = Object.keys(config.credentials);
        const credentialsNames = credentialsTypes.map((name) => `'${name}'`).join(", ");
        if (credentialsTypes.length > 1) {
          throw new StatesRuntimeError(
            `More than one type of AWS credentials were specified: ${credentialsNames}. Only one type may be specified`
          );
        }
      }
      if (config.credentials?.cognitoIdentityPool) {
        this.client = new import_client_lambda.LambdaClient({
          region: config.region,
          credentials: (0, import_credential_providers.fromCognitoIdentityPool)({
            ...config.credentials.cognitoIdentityPool,
            clientConfig: { region: config.region }
          })
        });
      } else if (config.credentials?.accessKeys) {
        this.client = new import_client_lambda.LambdaClient({ region: config.region, credentials: config.credentials.accessKeys });
      }
    } else {
      if (isBrowserEnvironment) {
        throw new StatesRuntimeError(
          "aws-local-stepfunctions is running in a browser environment and your state machine definition contains a state of type 'Task'. In order to invoke the Lambda function, you must provide an AWS region and credentials in the state machine constructor by passing the 'awsConfig' option."
        );
      }
    }
  }
  async invokeFunction(funcNameOrArn, payload) {
    const payloadBuffer = new TextEncoder().encode(JSON.stringify(payload));
    const invokeCommand = new import_client_lambda.InvokeCommand({
      FunctionName: funcNameOrArn,
      Payload: payloadBuffer
    });
    const invocationResult = await this.client.send(invokeCommand);
    let resultValue = null;
    if (invocationResult.Payload) {
      resultValue = new TextDecoder().decode(invocationResult.Payload);
      resultValue = JSON.parse(resultValue);
    }
    if (invocationResult.FunctionError) {
      const errorResult = resultValue;
      throw new LambdaInvocationError(
        errorResult.errorType,
        `${errorResult.errorType}: ${errorResult.errorMessage}`,
        errorResult
      );
    }
    return resultValue;
  }
};

// src/stateMachine/stateActions/TaskStateAction.ts
var TaskStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
    this.timeoutAbortController = new AbortController();
  }
  createTimeoutPromise(input, context) {
    const state = this.stateDefinition;
    if (!state.TimeoutSeconds && !state.TimeoutSecondsPath)
      return;
    let timeout;
    if (state.TimeoutSeconds) {
      timeout = state.TimeoutSeconds;
    } else if (state.TimeoutSecondsPath) {
      timeout = jsonPathQuery(state.TimeoutSecondsPath, input, context, {
        constraints: [IntegerConstraint.greaterThanOrEqual(1)]
      });
    }
    return new Promise((_, reject) => {
      const handleTimeoutAbort = () => clearTimeout(timeoutId);
      const timeoutId = setTimeout(() => {
        this.timeoutAbortController.signal.removeEventListener("abort", handleTimeoutAbort);
        reject(new StatesTimeoutError());
      }, timeout * 1e3);
      this.timeoutAbortController.signal.addEventListener("abort", handleTimeoutAbort, { once: true });
    });
  }
  async execute(input, context, options) {
    const state = this.stateDefinition;
    const racingPromises = [];
    const timeoutPromise = this.createTimeoutPromise(input, context);
    if (options.overrideFn) {
      const resultPromise = options.overrideFn(input);
      racingPromises.push(resultPromise);
    } else {
      const lambdaClient = new LambdaClient(options.awsConfig);
      const resultPromise = lambdaClient.invokeFunction(state.Resource, input);
      racingPromises.push(resultPromise);
    }
    if (timeoutPromise) {
      racingPromises.push(timeoutPromise);
    }
    const result = await Promise.race(racingPromises);
    this.timeoutAbortController.abort();
    return this.buildExecutionResult(result);
  }
};

// src/stateMachine/stateActions/WaitStateAction.ts
var WaitStateAction = class extends BaseStateAction {
  constructor(stateDefinition, stateName) {
    super(stateDefinition, stateName);
  }
  async execute(input, context, options) {
    const state = this.stateDefinition;
    if (options.waitTimeOverrideOption !== void 0) {
      await sleep(options.waitTimeOverrideOption, options.abortSignal);
      return this.buildExecutionResult(input);
    }
    if (state.Seconds) {
      await sleep(state.Seconds * 1e3, options.abortSignal);
    } else if (state.Timestamp) {
      const dateTimestamp = new Date(state.Timestamp);
      const currentTime = Date.now();
      const timeDiff = dateTimestamp.getTime() - currentTime;
      await sleep(timeDiff, options.abortSignal);
    } else if (state.SecondsPath) {
      const seconds = jsonPathQuery(state.SecondsPath, input, context, {
        constraints: [IntegerConstraint.greaterThanOrEqual(0)]
      });
      await sleep(seconds * 1e3, options.abortSignal);
    } else if (state.TimestampPath) {
      const timestamp = jsonPathQuery(state.TimestampPath, input, context, {
        constraints: [RFC3339TimestampConstraint]
      });
      const dateTimestamp = new Date(timestamp);
      const currentTime = Date.now();
      const timeDiff = dateTimestamp.getTime() - currentTime;
      await sleep(timeDiff, options.abortSignal);
    }
    return this.buildExecutionResult(input);
  }
};

// src/stateMachine/StateExecutor.ts
var import_cloneDeep2 = __toESM(require("lodash/cloneDeep.js"), 1);
var DEFAULT_MAX_ATTEMPTS = 3;
var DEFAULT_INTERVAL_SECONDS = 1;
var DEFAULT_BACKOFF_RATE = 2;
var DEFAULT_JITTER_STRATEGY = "NONE";
var WILDCARD_ERROR = "States.ALL";
var TASK_STATE_WILDCARD_ERROR = "States.TaskFailed";
var StateExecutor = class {
  constructor(stateName, stateDefinition) {
    this.stateName = stateName;
    this.stateDefinition = stateDefinition;
    this.retrierAttempts = "Retry" in this.stateDefinition ? new Array(this.stateDefinition.Retry.length).fill(0) : [];
    this.stateHandlers = {
      Task: this.executeTaskState,
      Parallel: this.executeParallelState,
      Map: this.executeMapState,
      Pass: this.executePassState,
      Wait: this.executeWaitState,
      Choice: this.executeChoiceState,
      Succeed: this.executeSucceedState,
      Fail: this.executeFailState
    };
  }
  /**
   * Execute the current state.
   */
  async execute(input, context, options) {
    const rawInput = (0, import_cloneDeep2.default)(input);
    try {
      const processedInput = this.processInput(input, context);
      const {
        stateResult: currResult,
        nextState,
        isEndState
      } = await this.stateHandlers[this.stateDefinition.Type](
        // @ts-expect-error Indexing `this.stateActions` by non-literal value produces a `never` type for the `this.stateDefinition` parameter of the handler being called
        this.stateDefinition,
        rawInput,
        processedInput,
        context,
        this.stateName,
        options
      );
      const processedResult = this.processResult(currResult, rawInput, context);
      return { stateResult: processedResult, nextState, isEndState };
    } catch (error) {
      options.eventLogger.dispatchStateFailedEvent(
        this.stateName,
        this.stateDefinition.Type,
        input,
        error
      );
      const { shouldRetry, waitTimeBeforeRetry, retrierIndex } = this.shouldRetry(error);
      if (shouldRetry) {
        const stateDefinition = this.stateDefinition;
        await sleep(waitTimeBeforeRetry, options.abortSignal);
        options.eventLogger.dispatchStateRetriedEvent(
          this.stateName,
          stateDefinition.Type,
          input,
          stateDefinition.Retry[retrierIndex],
          this.retrierAttempts[retrierIndex]
        );
        return this.execute(input, context, options);
      }
      const { nextState, errorOutput, resultPath, catcherIndex } = this.catchError(error);
      if (nextState && errorOutput) {
        const stateDefinition = this.stateDefinition;
        options.eventLogger.dispatchStateCaughtEvent(
          this.stateName,
          stateDefinition.Type,
          input,
          stateDefinition.Catch[catcherIndex]
        );
        return { stateResult: processResultPath(resultPath, rawInput, errorOutput), nextState, isEndState: false };
      }
      throw error;
    }
  }
  /**
   * Process the current input according to the `InputPath` and `Parameters` fields.
   */
  processInput(input, context) {
    let processedInput = input;
    if ("InputPath" in this.stateDefinition) {
      processedInput = processInputPath(this.stateDefinition.InputPath, processedInput, context);
    }
    if ("Parameters" in this.stateDefinition && this.stateDefinition.Type !== "Map") {
      processedInput = processPayloadTemplate(this.stateDefinition.Parameters, processedInput, context);
    }
    return processedInput;
  }
  /**
   * Process the current result according to the `ResultSelector`, `ResultPath` and `OutputPath` fields.
   */
  processResult(result, rawInput, context) {
    let processedResult = result;
    if ("ResultSelector" in this.stateDefinition) {
      processedResult = processPayloadTemplate(this.stateDefinition.ResultSelector, processedResult, context);
    }
    if ("ResultPath" in this.stateDefinition) {
      processedResult = processResultPath(this.stateDefinition.ResultPath, rawInput, processedResult);
    }
    if ("OutputPath" in this.stateDefinition) {
      processedResult = processOutputPath(this.stateDefinition.OutputPath, processedResult, context);
    }
    return processedResult;
  }
  /**
   * Decide whether this state should be retried, according to the `Retry` field.
   */
  shouldRetry(error) {
    if (!("Retry" in this.stateDefinition)) {
      return { shouldRetry: false };
    }
    for (let i = 0; i < this.stateDefinition.Retry.length; i++) {
      const retrier = this.stateDefinition.Retry[i];
      const jitterStrategy = retrier.JitterStrategy ?? DEFAULT_JITTER_STRATEGY;
      const maxAttempts = retrier.MaxAttempts ?? DEFAULT_MAX_ATTEMPTS;
      const intervalSeconds = retrier.IntervalSeconds ?? DEFAULT_INTERVAL_SECONDS;
      const backoffRate = retrier.BackoffRate ?? DEFAULT_BACKOFF_RATE;
      const waitInterval = intervalSeconds * Math.pow(backoffRate, this.retrierAttempts[i]);
      const retryable = error.isRetryable ?? true;
      let waitTimeBeforeRetry = clamp(waitInterval, 1, retrier.MaxDelaySeconds) * 1e3;
      if (jitterStrategy === "FULL") {
        waitTimeBeforeRetry = getRandomNumber(0, waitTimeBeforeRetry);
      }
      for (const retrierError of retrier.ErrorEquals) {
        const isErrorMatch = retrierError === error.name;
        const isErrorWildcard = retrierError === WILDCARD_ERROR;
        const isErrorTaskWildcard = retrierError === TASK_STATE_WILDCARD_ERROR && this.stateDefinition.Type === "Task" && !(error instanceof StatesTimeoutError);
        const maybeShouldRetry = retryable && (isErrorMatch || isErrorWildcard || isErrorTaskWildcard);
        if (maybeShouldRetry) {
          if (this.retrierAttempts[i] >= maxAttempts)
            return { shouldRetry: false };
          this.retrierAttempts[i]++;
          return { shouldRetry: true, waitTimeBeforeRetry, retrierIndex: i };
        }
      }
    }
    return { shouldRetry: false };
  }
  /**
   * Try to match the current error with a catcher, according to the `Catch` field.
   */
  catchError(error) {
    if (!("Catch" in this.stateDefinition)) {
      return { nextState: "" };
    }
    for (let i = 0; i < this.stateDefinition.Catch.length; i++) {
      const catcher = this.stateDefinition.Catch[i];
      const catchable = error.isCatchable ?? true;
      for (const catcherError of catcher.ErrorEquals) {
        const isErrorMatch = catcherError === error.name;
        const isErrorWildcard = catcherError === WILDCARD_ERROR;
        const isErrorTaskWildcard = catcherError === TASK_STATE_WILDCARD_ERROR && this.stateDefinition.Type === "Task" && !(error instanceof StatesTimeoutError);
        const shouldCatch = catchable && (isErrorMatch || isErrorWildcard || isErrorTaskWildcard);
        if (shouldCatch) {
          const nextState = catcher.Next;
          const errorOutput = {
            Error: error.name,
            Cause: error.message
          };
          const resultPath = catcher.ResultPath;
          return { nextState, errorOutput, resultPath, catcherIndex: i };
        }
      }
    }
    return { nextState: "" };
  }
  /**
   * Handler for task states.
   *
   * Invokes the Lambda function specified in the `Resource` field
   * and sets the current result of the state machine to the value returned by the Lambda.
   */
  async executeTaskState(stateDefinition, rawInput, input, context, stateName, options) {
    const overrideFn = options.runOptions?.overrides?.taskResourceLocalHandlers?.[stateName];
    const awsConfig = options.stateMachineOptions?.awsConfig;
    const taskStateAction = new TaskStateAction(stateDefinition, stateName);
    const executionResult = await taskStateAction.execute(input, context, { overrideFn, awsConfig });
    return executionResult;
  }
  /**
   * Handler for parallel states.
   *
   * Creates a new state machine for each of the branches specified in the `Branches` field,
   * and then executes each branch state machine by passing them the Parallel state input.
   */
  async executeParallelState(stateDefinition, rawInput, input, context, stateName, options) {
    const parallelStateAction = new ParallelStateAction(stateDefinition, stateName);
    const executionResult = await parallelStateAction.execute(input, context, {
      stateMachineOptions: options.stateMachineOptions,
      runOptions: options.runOptions,
      eventLogger: options.eventLogger,
      rawInput
    });
    return executionResult;
  }
  /**
   * Handler for map states.
   *
   * Iterates over the current input items or the items of an array specified
   * by the `ItemsPath` field, and then processes each item by passing it
   * as the input to the state machine specified in the `Iterator` field.
   */
  async executeMapState(stateDefinition, rawInput, input, context, stateName, options) {
    const mapStateAction = new MapStateAction(stateDefinition, stateName);
    const executionResult = await mapStateAction.execute(input, context, {
      stateMachineOptions: options.stateMachineOptions,
      runOptions: options.runOptions,
      eventLogger: options.eventLogger,
      rawInput
    });
    return executionResult;
  }
  /**
   * Handler for pass states.
   *
   * If the `Result` field is specified, copies `Result` into the current result.
   * Else, copies the current input into the current result.
   */
  async executePassState(stateDefinition, rawInput, input, context, stateName, options) {
    const passStateAction = new PassStateAction(stateDefinition, stateName);
    const executionResult = await passStateAction.execute(input, context);
    return executionResult;
  }
  /**
   * Handler for wait states.
   *
   * Pauses the state machine execution for a certain amount of time
   * based on one of the `Seconds`, `Timestamp`, `SecondsPath` or `TimestampPath` fields.
   */
  async executeWaitState(stateDefinition, rawInput, input, context, stateName, options) {
    const waitTimeOverrideOption = options.runOptions?.overrides?.waitTimeOverrides?.[stateName];
    const waitStateAction = new WaitStateAction(stateDefinition, stateName);
    const executionResult = await waitStateAction.execute(input, context, {
      waitTimeOverrideOption,
      abortSignal: options.abortSignal
    });
    return executionResult;
  }
  /**
   * Handler for choice states.
   *
   * Evaluates each choice rule specified in the `Choices` field.
   *
   * If one of the rules matches, then the state machine transitions to the
   * state specified in the `Next` field for that choice rule.
   *
   * If no rule matches but the `Default` field is specified,
   * then the next state will be the state specified in said field.
   *
   * If no rule matches and the `Default` field is not specified, throws a
   * States.NoChoiceMatched error.
   */
  async executeChoiceState(stateDefinition, rawInput, input, context, stateName, options) {
    const choiceStateAction = new ChoiceStateAction(stateDefinition, stateName);
    const executionResult = await choiceStateAction.execute(input, context);
    return executionResult;
  }
  /**
   * Handler for succeed states.
   *
   * Ends the state machine execution successfully.
   */
  async executeSucceedState(stateDefinition, rawInput, input, context, stateName, options) {
    const succeedStateAction = new SucceedStateAction(stateDefinition, stateName);
    const executionResult = await succeedStateAction.execute(input, context);
    return executionResult;
  }
  /**
   * Handler for fail states.
   *
   * Ends the state machine execution and marks it as a failure.
   */
  async executeFailState(stateDefinition, rawInput, input, context, stateName, options) {
    const failStateAction = new FailStateAction(stateDefinition, stateName);
    const executionResult = await failStateAction.execute(input, context);
    return executionResult;
  }
};

// src/stateMachine/EventLogger.ts
var EventLogger = class {
  constructor() {
    this.eventTarget = new EventTarget();
    this.eventQueue = [];
    this.isLoggerClosed = false;
  }
  async *getEvents() {
    while (true) {
      if (this.eventQueue.length === 0) {
        await this.waitForNewEvent();
      }
      let event = null;
      while (event = this.eventQueue.shift()) {
        yield event;
      }
      if (this.isLoggerClosed)
        return;
    }
  }
  /**
   * Forward nested events created by `Map` states, to the root state machine event logger.
   * @param event An event dispatched by the nested state machine spawned by a `Map` state.
   * @param index Index of the current iteration being processed.
   * @param mapStateName Name of the `Map` state being executed.
   * @param mapStateRawInput Raw input passed to the `Map` state being executed.
   */
  forwardNestedMapEvent(event, index, mapStateName, mapStateRawInput) {
    switch (event.type) {
      case "ExecutionStarted":
        this.dispatchMapIterationStartedEvent(event, index, mapStateName, mapStateRawInput);
        break;
      case "ExecutionSucceeded":
        this.dispatchMapIterationSucceededEvent(event, index, mapStateName, mapStateRawInput);
        break;
      case "ExecutionFailed":
        this.dispatchMapIterationFailedEvent(event, index, mapStateName, mapStateRawInput);
        break;
      case "StateEntered":
      case "StateExited":
      case "StateFailed":
      case "StateRetried":
      case "StateCaught":
        event.index = index;
        this.dispatch(event);
        break;
      case "ExecutionAborted":
      case "ExecutionTimeout":
        return;
      default:
        this.dispatch(event);
        break;
    }
  }
  /**
   * Forward nested events created by `Parallel` states, to the root state machine event logger.
   * @param event An event dispatched by the nested state machines spawned by a `Parallel` state.
   * @param parallelStateName Name of the `Parallel` state being executed.
   * @param parallelStateRawInput Raw input passed to the `Parallel` state being executed.
   */
  forwardNestedParallelEvent(event, parallelStateName, parallelStateRawInput) {
    switch (event.type) {
      case "ExecutionStarted":
        this.dispatchParallelBranchStartedEvent(event, parallelStateName, parallelStateRawInput);
        break;
      case "ExecutionSucceeded":
        this.dispatchParallelBranchSucceededEvent(event, parallelStateName, parallelStateRawInput);
        break;
      case "ExecutionFailed":
        this.dispatchParallelBranchFailedEvent(event, parallelStateName, parallelStateRawInput);
        break;
      case "ExecutionAborted":
      case "ExecutionTimeout":
        return;
      default:
        this.dispatch(event);
        break;
    }
  }
  dispatchExecutionStartedEvent(input) {
    this.dispatch({ type: "ExecutionStarted", timestamp: Date.now(), input });
  }
  dispatchExecutionSucceededEvent(output) {
    this.dispatch({ type: "ExecutionSucceeded", timestamp: Date.now(), output });
    this.close();
  }
  dispatchExecutionFailedEvent(error) {
    this.dispatch({
      type: "ExecutionFailed",
      timestamp: Date.now(),
      Error: error.name,
      Cause: error.cause ?? error.message
    });
    this.close();
  }
  dispatchExecutionAbortedEvent() {
    this.dispatch({ type: "ExecutionAborted", timestamp: Date.now() });
    this.close();
  }
  dispatchExecutionTimeoutEvent() {
    this.dispatch({ type: "ExecutionTimeout", timestamp: Date.now() });
    this.close();
  }
  dispatchStateEnteredEvent(stateName, stateType, input) {
    this.dispatch({
      type: "StateEntered",
      timestamp: Date.now(),
      state: { name: stateName, type: stateType, input }
    });
  }
  dispatchStateExitedEvent(stateName, stateType, input, output) {
    this.dispatch({
      type: "StateExited",
      timestamp: Date.now(),
      state: { name: stateName, type: stateType, input, output }
    });
  }
  dispatchStateFailedEvent(stateName, stateType, input, error) {
    this.dispatch({
      type: "StateFailed",
      timestamp: Date.now(),
      state: { name: stateName, type: stateType, input },
      Error: error.name,
      Cause: error.cause ?? error.message
    });
  }
  dispatchStateRetriedEvent(stateName, stateType, input, retrier, retryAttempt) {
    this.dispatch({
      type: "StateRetried",
      timestamp: Date.now(),
      state: { name: stateName, type: stateType, input },
      retry: { retrier, attempt: retryAttempt }
    });
  }
  dispatchStateCaughtEvent(stateName, stateType, input, catcher) {
    this.dispatch({
      type: "StateCaught",
      timestamp: Date.now(),
      state: { name: stateName, type: stateType, input },
      catch: { catcher }
    });
  }
  dispatchMapIterationStartedEvent(event, index, mapStateName, mapStateRawInput) {
    this.dispatch({
      ...event,
      type: "MapIterationStarted",
      index,
      parentState: { type: "Map", name: mapStateName, input: mapStateRawInput }
    });
  }
  dispatchMapIterationSucceededEvent(event, index, mapStateName, mapStateRawInput) {
    this.dispatch({
      ...event,
      type: "MapIterationSucceeded",
      index,
      parentState: { type: "Map", name: mapStateName, input: mapStateRawInput }
    });
  }
  dispatchMapIterationFailedEvent(event, index, mapStateName, mapStateRawInput) {
    this.dispatch({
      ...event,
      type: "MapIterationFailed",
      index,
      parentState: { type: "Map", name: mapStateName, input: mapStateRawInput }
    });
  }
  dispatchParallelBranchStartedEvent(event, parallelStateName, parallelStateRawInput) {
    this.dispatch({
      ...event,
      type: "ParallelBranchStarted",
      parentState: { type: "Parallel", name: parallelStateName, input: parallelStateRawInput }
    });
  }
  dispatchParallelBranchSucceededEvent(event, parallelStateName, parallelStateRawInput) {
    this.dispatch({
      ...event,
      type: "ParallelBranchSucceeded",
      parentState: { type: "Parallel", name: parallelStateName, input: parallelStateRawInput }
    });
  }
  dispatchParallelBranchFailedEvent(event, parallelStateName, parallelStateRawInput) {
    this.dispatch({
      ...event,
      type: "ParallelBranchFailed",
      parentState: { type: "Parallel", name: parallelStateName, input: parallelStateRawInput }
    });
  }
  close() {
    this.isLoggerClosed = true;
    this.eventTarget.dispatchEvent(new Event("newEvent"));
  }
  dispatch(event) {
    if (this.isLoggerClosed)
      return;
    this.eventQueue.push(event);
    this.eventTarget.dispatchEvent(new Event("newEvent"));
  }
  waitForNewEvent() {
    if (this.isLoggerClosed)
      return;
    return new Promise((resolve) => {
      this.eventTarget.addEventListener("newEvent", resolve, { once: true });
    });
  }
};

// src/stateMachine/StateMachine.ts
var import_asl_validator = __toESM(require("asl-validator"), 1);
var import_cloneDeep3 = __toESM(require("lodash/cloneDeep.js"), 1);
var StateMachine = class {
  /**
   * Constructs a new state machine.
   * @param definition The state machine definition defined using the Amazon States Language (https://states-language.net/spec.html).
   * @param stateMachineOptions Options to control certain settings of the state machine.
   * These options also apply to state machines defined in the `Iterator` field of `Map` states and in the `Branches` field of `Parallel` states.
   */
  constructor(definition, stateMachineOptions) {
    if (!stateMachineOptions?.validationOptions?.noValidate) {
      const { isValid, errorsText } = (0, import_asl_validator.default)(definition, {
        checkArn: true,
        checkPaths: true,
        ...stateMachineOptions?.validationOptions
      });
      if (!isValid) {
        throw new Error(`State machine definition is invalid, see error(s) below:
 ${errorsText("\n")}`);
      }
    }
    this.definition = definition;
    this.stateMachineOptions = stateMachineOptions;
  }
  /**
   * Executes the state machine, running through the states specified in the definition.
   * If the execution fails, the result will throw an `ExecutionError` explaining why the
   * execution failed.
   *
   * If the execution times out because the number of seconds specified in
   * the `TimeoutSeconds` top-level field has elapsed, the result will throw an `ExecutionTimeoutError`.
   *
   * By default, if the execution is aborted, the result will throw an `ExecutionAbortedError`. This behavior can be changed by setting
   * the `noThrowOnAbort` option to `true`, in which case the result will be `null`.
   *
   * @param input The input to pass to this state machine execution.
   * @param options Miscellaneous options to control certain behaviors of the execution.
   */
  run(input, options) {
    const abortController = new AbortController();
    const eventLogger = new EventLogger();
    let rootSignalAbortHandler;
    if (options?._rootAbortSignal) {
      rootSignalAbortHandler = () => abortController.abort();
      if (options._rootAbortSignal.aborted) {
        rootSignalAbortHandler();
      } else {
        options._rootAbortSignal.addEventListener("abort", rootSignalAbortHandler);
      }
    }
    let onAbortHandler;
    const settleOnAbort = new Promise((resolve, reject) => {
      if (options?.noThrowOnAbort) {
        onAbortHandler = () => {
          eventLogger.dispatchExecutionAbortedEvent();
          resolve(null);
        };
      } else {
        onAbortHandler = () => {
          eventLogger.dispatchExecutionAbortedEvent();
          reject(new ExecutionAbortedError());
        };
      }
      abortController.signal.addEventListener("abort", onAbortHandler);
    });
    let rejectOnTimeout;
    let timeoutId;
    if (this.definition.TimeoutSeconds !== void 0) {
      rejectOnTimeout = new Promise((_, reject) => {
        timeoutId = setTimeout(() => {
          abortController.signal.removeEventListener("abort", onAbortHandler);
          abortController.abort();
          eventLogger.dispatchExecutionTimeoutEvent();
          reject(new ExecutionTimeoutError());
        }, this.definition.TimeoutSeconds * 1e3);
      });
    }
    const executionResult = this.execute(
      input,
      {
        stateMachineOptions: this.stateMachineOptions,
        runOptions: { ...options, _rootAbortSignal: options?._rootAbortSignal ?? abortController.signal },
        abortSignal: abortController.signal,
        eventLogger
      },
      () => {
        abortController.signal.removeEventListener("abort", onAbortHandler);
        options?._rootAbortSignal?.removeEventListener("abort", rootSignalAbortHandler);
        clearTimeout(timeoutId);
      }
    );
    const racingPromises = [executionResult, settleOnAbort];
    if (rejectOnTimeout) {
      racingPromises.push(rejectOnTimeout);
    }
    const result = Promise.race(racingPromises);
    return {
      abort: () => abortController.abort(),
      eventLogs: eventLogger.getEvents(),
      result
    };
  }
  /**
   * Helper method that handles the execution of the machine states and the transitions between them.
   */
  async execute(input, options, cleanupFn) {
    options.eventLogger.dispatchExecutionStartedEvent(input);
    const context = options.runOptions?.context ?? {};
    let currState = this.definition.States[this.definition.StartAt];
    let currStateName = this.definition.StartAt;
    let currInput = (0, import_cloneDeep3.default)(input);
    let currResult = null;
    let nextState = "";
    let isEndState = false;
    try {
      do {
        options.eventLogger.dispatchStateEnteredEvent(currStateName, currState.Type, currInput);
        const stateExecutor = new StateExecutor(currStateName, currState);
        ({ stateResult: currResult, nextState, isEndState } = await stateExecutor.execute(currInput, context, options));
        options.eventLogger.dispatchStateExitedEvent(currStateName, currState.Type, currInput, currResult);
        currInput = currResult;
        currState = this.definition.States[nextState];
        currStateName = nextState;
      } while (!isEndState && !options.abortSignal.aborted);
    } catch (error) {
      options.eventLogger.dispatchExecutionFailedEvent(error);
      throw new ExecutionError(error);
    } finally {
      cleanupFn();
    }
    options.eventLogger.dispatchExecutionSucceededEvent(currResult);
    return currResult;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ExecutionAbortedError,
  ExecutionError,
  ExecutionTimeoutError,
  StateMachine
});
